#pragma config(Sensor, S4,     NXT2WIFI,       sensorHighSpeed)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * benedettelli-nxt2wifi.h provides an API for Daniele's NXT2WiFi Sensor. This program allows
 * to quickly retrieve the IP address and MAC so you can activate the sensor.  It will do the following:
 * - Delete the custom profile
 * - Reset the device
 * - Setup the default profile, which is an AdHoc network called NXT2WIFI
 *
 * When it's done setting up the AdHoc network, it will display the IP and MAC address. Use the MAC
 * address to retrieve an activation key from http://dev.openpicus.com/Firmware/NXT2WIFI
 *
 * Connect to the AdHoc network (NXT2WIFI) and point your browser to http://<IP on NXT>/activate.htm to activate
 * it using the code you got from the activation page.
 *
 * You're now good to go!
 *
 * This program is also very useful if you want to update the web site on the NXT2WIFI.  I have found that updating
 * the pages through the AdHoc network is far quicker and more reliable.
 *
 * Use benedetelli-nxt2wifi-config.c to create a custom profile
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * Credits:
 * - Big thanks to Daniele Benedettelli for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 22 July 2012
 * version 0.1
 */
#define __RS485_DEBUG__
#include "common.h"
#include "benedettelli-nxt2wifi.h"

//string returnMsg;
string IPaddress;
string MACaddress;

task main ()
{
  displayTextLine(0, "Stat: disconnected");
  displayTextLine(2, "-------------------");

  // port to use for the socket
  string dataString;

  // get our bluetooth name
  getFriendlyName(dataString);

  // initialise the port, etc
  RS485initLib();
  N2WchillOut();

  N2WsetDebug(true);
  N2WchillOut();

  // Disconnect if already connected
  N2WDisconnect();
  sleep(100);

  // Delete the custom profile and reset the device
  N2WDelete();
  sleep(100);
  N2WReset();
  displayTextLine(0, "Stat: Resetting");
  sleep(5000);

  // Connect to the default profile (AdHoc)
  displayTextLine(0, "Stat: Connecting");
  N2WConnect(false);

  while (!N2WConnected())
    sleep(500);

  sleep(2000);
  N2WgetIP(IPaddress);
  displayTextLine(4, IPaddress);
  sleep(100);
  N2WgetMAC(MACaddress);
  displayTextLine(5, MACaddress);
  displayTextLine(0, "Stat: Connected");
  playSound(soundBeepBeep);

  while(true) sleep(1);

}
