#pragma config(Sensor, S1,     DFLEX,               sensorAnalogInactive)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * dexterind-flex.h provides an API for the Dexter Industries dFlex Sensor.  This program
 * demonstrates how to use that API to calibrate the sensor.
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * Credits:
 * - Big thanks to Dexter Industries for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 23 June 2010
 * version 0.1
 */

#include "dexterind-flex.h"

task main () {
  short raw = 0;
  short nrm = 0;
  // Get control over the buttons
  nNxtButtonTask  = -2;

  eraseDisplay();
  displayTextLine(0, "Dexter Industries");
  displayCenteredBigTextLine(1, "dFlex");
  displayCenteredTextLine(3, "Test 2");
  displayCenteredTextLine(5, "Connect sensor");
  displayCenteredTextLine(6, "to S1");
  sleep(2000);

  eraseDisplay();
  displayTextLine(0, "dFlex Calibration");
  displayTextLine(2, "Left:  set min");
  displayTextLine(3, "Right: set max");
  displayTextLine(7, "Grey:  exit");

  while (true) {
    switch(nNxtButtonPressed) {
      // if the left button is pressed calibrate the black value for the sensor
      case kLeftButton:
                        DFLEXcalLow(DFLEX);
                        playSound(soundBeepBeep);
                        while(bSoundActive) sleep(1);
                        break;

      // if the left button is pressed calibrate the white value for the sensor
      case kRightButton:
                        DFLEXcalHigh(DFLEX);
                        playSound(soundBeepBeep);
                        while(bSoundActive) sleep(1);
                        break;
    }

    displayClearTextLine(5);
    displayClearTextLine(6);

    // Read the raw value of the sensor
    raw = DFLEXvalRaw(DFLEX);

    // Read the normalised value of the sensor
    nrm = DFLEXvalNorm(DFLEX);

    // Display the raw and normalised values
    displayTextLine(5, "R: %4d N: %4d", raw, nrm);

    // Display the values for black and white
    displayTextLine(6, "B: %4d W: %4d", dflexlow, dflexhigh);
    sleep(50);
  }
}
