#pragma config(Sensor, S1,     HTBM,                sensorI2CCustom)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * hitechnic-barometer.h provides an API for the HiTechnic Barometric Sensor.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 * - 0.2: Removed common.h from includes
 *
 * Credits:
 * - Big thanks to HiTechnic for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 30 October 2010
 * version 0.1
 */

#include "hitechnic-barometer.h"

task main () {

  displayCenteredTextLine(0, "HiTechnic");
  displayCenteredBigTextLine(1, "BaroTemp");
  displayCenteredTextLine(3, "Test 1");
  displayCenteredTextLine(5, "Connect sensor");
  displayCenteredTextLine(6, "to S1");
  sleep(2000);

  // Create struct to hold sensor data
  tHTBM pressureSensor;

  // Initialise and configure struct and port
  initSensor(&pressureSensor, S1);

  while (true) {
    eraseDisplay();

    // Read the sensor's data
    readSensor(&pressureSensor);

    displayCenteredTextLine(0, "HTBM Test 1");
    displayTextLine(2, "%5d mInHg", pressureSensor.mInHg);
    displayTextLine(3, "%5.1f hPa", pressureSensor.hPa);
    displayTextLine(4, "%5.1f PSI", pressureSensor.Psi);
    displayTextLine(6, "%3.1f C / %3.1f F", pressureSensor.Celcius, pressureSensor.Fahrenheit);
    drawLine(0, 52, 99, 52);
    drawLine(0, 20, 99, 20);
    sleep(100);
  }
}
