#pragma config(Sensor, S1,     HTSMUX,              sensorI2CCustom)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * HTCS-driver.h provides an API for the HiTechnic EOPD Sensor.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 * - 0.2: Now uses HTSMUX driver which has been split from common.h\n
 *        HTSMUX initialisation and scanning functions have been removed\n
 *
 * Credits:
 * - Big thanks to HiTechnic for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 20 February 2011
 * version 0.2
 */

#include "hitechnic-eopd.h"

task main() {
  nNxtButtonTask  = -2;

  eraseDisplay();
  displayCenteredTextLine(0, "HiTechnic");
  displayCenteredBigTextLine(1, "EOPD");
  displayCenteredTextLine(3, "SMUX Test");
  displayCenteredTextLine(5, "Connect SMUX to");
  displayCenteredTextLine(6, "S1 and sensor to");
  displayCenteredTextLine(7, "SMUX Port 1");
  sleep(2000);

  displayCenteredTextLine(5, "Press enter to");
  displayCenteredTextLine(6, "switch between");
  displayCenteredTextLine(7, "ranges");
  sleep(2000);
  eraseDisplay();

  // Create struct to hold sensor data
  tHTEOPD eopdSensor;

  // Initialise and configure struct and port
  // The sensor is connected to the first port
  // of the SMUX which is connected to the NXT port S1.
  // To access that sensor, we must use msensor_S1_1.  If the sensor
  // were connected to 3rd port of the SMUX connected to the NXT port S4,
  // we would use msensor_S4_3
  initSensor(&eopdSensor, msensor_S1_1);

  while(true) {
    if (time1[T1] > 1000) {
      if (eopdSensor.shortRange == false) {
        // set the sensor to short range and display this
      	eopdSensor.shortRange = true;
      	configSensor(&eopdSensor);
        displayClearTextLine(1);
        displayTextLine(1, "Short range");
      } else {
        // set the sensor to long range and display this
      	eopdSensor.shortRange = false;
      	configSensor(&eopdSensor);
        displayClearTextLine(1);
        displayTextLine(1, "Long range");
      }
      playSound(soundBeepBeep);
      while(bSoundActive)
      time1[T1] = 0;
    }

    while(nNxtButtonPressed != kEnterButton) {
      // Read the sensor values, both the raw and the processed one,
    	// which is linear with the distance detected.  Use the processed
      // value when you want to determine distance to an object
    	readSensor(&eopdSensor);

      displayClearTextLine(3);
      displayClearTextLine(4);
      displayTextLine(4, "Proc:  %4d", eopdSensor.processed);
      displayTextLine(3, "Raw :  %4d", eopdSensor.raw);
      sleep(50);
    }
  }
}
