#pragma config(Sensor, S1,     HTPB,                sensorI2CCustom9V)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * hitechnic-protoboard.h provides an API for the HiTechnic Protoboard.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 * - 0.2: More comments
 *
 * Credits:
 * - Big thanks to HiTechnic for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 25 November 2009
 * version 0.2
 */

#include "hitechnic-protoboard.h"

task main() {
  short _chVal = 0;

  displayCenteredTextLine(0, "HiTechnic");
  displayCenteredBigTextLine(1, "Proto");
  displayCenteredTextLine(3, "Test 1");
  displayCenteredTextLine(5, "Connect HTPB");
  displayCenteredTextLine(6, "to S1");

  sleep(2000);
  // Setup all the digital IO ports as outputs (0xFF)
  if (!HTPBsetupIO(HTPB, 0xFF)) {
    displayTextLine(4, "ERROR!!");
    sleep(2000);
    stopAllTasks();
  }

  while(true) {
    eraseDisplay();
    // get the value for ADC channel 0, we want a 10 bit answer
    _chVal = HTPBreadADC(HTPB, 0, 10);
    displayTextLine(4, "A0: %d", _chVal);

    // if _chVal is more than 512, turn on the LED, otherwise turn it off.
    if (_chVal > 512) {
      if (!HTPBwriteIO(HTPB, 0xFF)) displayTextLine(5, "ERR WRITE");
    } else {
      if (!HTPBwriteIO(HTPB, 0x00)) displayTextLine(5, "ERR WRITE");
    }
    sleep(100);
  }
}
