#pragma config(Sensor, S1,     HTTMUX,              sensorAnalogInactive)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * hitechnic-touchmux.h provides an API for the HiTechnic Touch Sensor MUX.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 * - 0.2: More comments
 *
 * Credits:
 * - Big thanks to HiTechnic for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 25 November 2009
 * version 0.2
 */

#include "hitechnic-touchmux.h"

task main () {
  displayCenteredTextLine(0, "HiTechnic");
  displayCenteredBigTextLine(1, "TMUX");
  displayCenteredTextLine(3, "Test 1");
  displayCenteredTextLine(5, "This is for the");
  displayCenteredTextLine(6, "Touch MUX");
  sleep(2000);

  // Create struct to hold sensor data
  tHTTMUX touchMUX;

  // Initialise and configure struct and port
  initSensor(&touchMUX, S1);

  while (true) {
    eraseDisplay();
    displayTextLine(0, "HT Touch MUX");

    // Read the data from the sensor
    readSensor(&touchMUX);

    // Go through each possible touch switch attached to the TMUX
    // and display whether or not is active (pressed)
    for (short i = 0; i < 4; i++) {
      if (touchMUX.status[i])
        displayTextLine(i+2, "Touch %d: on", i+1);
      else
        displayTextLine(i+2, "Touch %d: off", i+1);
    }

    // Display the binary value of the active touch switches
    // 0 = no touch, 1 = touch 1 active, 2 = touch 2 active, etc.
    // touch 1 + touch 2 active = 1 + 2 = 3.
    displayTextLine(7, "Mask: %d", touchMUX.statusMask);
    sleep(50);
  }
}
