#pragma config(Sensor, S1,     MSMTRMX,             sensorI2CCustomFastSkipStates)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * mindsensors-rcxmotormux.h provides an API for the Mindsensors RCX Motor MUX.
 * This program demonstrates how to use the driver for the Mindsensors RCX Motor Mux.
 * Plug the mux into sensor port 1, and a motor into motor output 1. The motor will
 * gradually speed up to full power and then back again, and then the same backwards.
 * It will then gradually increase the braking force from nothing to full power, and
 * back to zero, before turning the motor off
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Daniel Playfair Cal (daniel.playfair.cal_at_gmail.com)
 * 20 September 2011
 * version 0.1
 */

#include "mindsensors-rcxmotormux.h"

task main () {

  // Gradually speed up
  for (short power = 0; power <= 255; power++) {
    MSMTRMX_Control (MSMTRMX, MSMTRMX_M1, power);
    sleep (20);
  }

  // Gradually slow down
  for (short power = 255; power >=1; power--) {
    MSMTRMX_Control (MSMTRMX, MSMTRMX_M1, power);
    sleep (20);
  }

  // The same backwards
  for (short power = 0; power >= -255; power--) {
    MSMTRMX_Control (MSMTRMX, MSMTRMX_M1, power);
    sleep (20);
  }

  // Slow down again
  for (short power = -255; power <= -1; power++) {
    MSMTRMX_Control (MSMTRMX, MSMTRMX_M1, power);
    sleep (20);
  }

  // Gradually increase braking force
  for (short force = 0; force <= 255; force++) {
    MSMTRMX_Brake (MSMTRMX, MSMTRMX_M1, force);
    sleep (20);
  }

  // Gradually reduce braing force
  for (short force = 255; force >=1; force--) {
    MSMTRMX_Brake (MSMTRMX, MSMTRMX_M1, force);
    sleep (20);
  }

  // Turn off the motor
  MSMTRMX_Control (MSMTRMX, MSMTRMX_M1, 0);
}
