#pragma config(Sensor, S1,     MSRXMUX,             sensorI2CCustom9V)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * mindsensors-rcxsensorsmux.h provides an API for the Mindsensors RCX Sensor MUX Sensor.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 * - 0.2: More comments
 *
 * Credits:
 * - Big thanks to Mindsensors for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 28 November 2009
 * version 0.2
 */

#include "mindsensors-rcxsensorsmux.h"

task main () {

  short chan1 = 0;
  short chan2 = 0;
  short chan4 = 0;

  displayCenteredTextLine(0, "Mindsensors");
  displayCenteredBigTextLine(1, "RXMUX");
  displayCenteredTextLine(3, "Test 1");

  sleep(2000);

  // Set up channel 1 on the RCX sensor MUX to a light sensor in percentage mode
  MSRXMUXsetupChan(MSRXMUX, 1, sensorReflection, modePercentage, 5);

  // Set up channel 2 on the RCX sensor MUX to a touch sensor in raw mode
  MSRXMUXsetupChan(MSRXMUX, 2, sensorTouch, modeRaw, 5);

  // Set up channel 4 on the RCX sensor MUX to rotation sensor in rotation mode
  MSRXMUXsetupChan(MSRXMUX, 4, sensorRotation, modeRotation, 5);

  while(true) {
    // Read from the channels and display
    chan1 = MSRXMUXreadChan(MSRXMUX, 1);
    chan2 = MSRXMUXreadChan(MSRXMUX, 2);
    chan4 = MSRXMUXreadChan(MSRXMUX, 4);
    displayBigTextLine(1, "%d", chan1);
    displayBigTextLine(3, "%d", chan2);
    displayBigTextLine(5, "%d", chan4);
  }

  playSound(soundBeepBeep);
  while(bSoundActive) sleep(1);
  eraseDisplay();
  while(1) sleep(1);

}
