#pragma config(Sensor, S1,     MSSMUX,         sensorI2CCustom)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * mindsensors-sensormux.h provides an API for the Mindsensors SensorMUX Sensor.
 * This program demonstrates how to use that API to read multiple sensors
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * Credits:
 * - Big thanks to Mindsensors for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 03 March 2013
 * version 0.1
 */

#include "mindsensors-sensormux.h"
#include "mindsensors-angle.h"
#include "mindsensors-accelerometer.h"

task main()
{
  short voltage = 0;
  short angle;
  short x, y, z;
  displayCenteredTextLine(0, "Mindsensors");
  displayCenteredBigTextLine(1, "SnsrMUX");
  displayCenteredTextLine(3, "Test 1");

  sleep(2000);
  eraseDisplay();

  displayCenteredTextLine(0, "SensorMUX");
  displayCenteredTextLine(1, "Multi-test");
  while(true)
  {
    // Read the voltage of the battery connected to the SMUX
    // This returns a value in mV
    voltage = MSSMUXreadBattery(MSSMUX);

    // To read from a specific channel, you must switch
    // to it and then set up the port for that specific sensor

    // We have a Mindsensors accelerometer attached to channel 1
    MSSMUXsetChan(MSSMUX, 1);
    SensorType[MSSMUX] = sensorI2CCustom;
    MSACreadAccel(MSSMUX, x, y, z);

    // We have a Angle Sensor attached to channel 2
    MSSMUXsetChan(MSSMUX, 2);
    SensorType[MSSMUX] = sensorI2CCustom;
    angle = MSANGreadAngle(MSSMUX);

    displayTextLine(3, "Batt: %d mV", voltage);
    displayTextLine(4, "Angle: %d deg", angle);
    displayTextLine(5, "Tilt: ");
    displayTextLine(6, "%d, %d, %d", x, y, z);
  }
}
