#pragma config(Sensor, S2,     HTMSSUMO,            sensorLightActive)
#pragma config(Motor,  motorA,          RIGHT,         tmotorNormal, PIDControl, encoder)
#pragma config(Motor,  motorB,          LEFT,          tmotorNormal, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * mindsensors-sumoeyes.h provides an API for the Mindsensors Sumo Eyes Sensor.  This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * Credits:
 * - Big thanks to Mindsensors for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 20 February 2011
 * version 0.4
 */

#include "mindsensors-sumoeyes.h"

 /*
  =============================================================================
  main task with some testing code

 */
task main() {
  // Standard range is set to short range
  bool shortrange = true;
  tObstacleZone zone = MSSUMO_NONE;
  nNxtButtonTask  = -2;

  eraseDisplay();

  displayCenteredTextLine(0, "Mindsensors");
  displayCenteredBigTextLine(1, "SumoEyes");
  displayCenteredTextLine(3, "Test 2");
  displayCenteredTextLine(5, "Press enter to");
  displayCenteredTextLine(6, "switch between");
  displayCenteredTextLine(7, "ranges");
  sleep(2000);
  eraseDisplay();

  // Set the sensor to short range
  MSSUMOsetShortRange(HTMSSUMO);
  displayRICFile(0, 0, "sumonone.ric");

  while(true) {
    if (time1[T1] > 1000) {
      if (shortrange == false) {
        // set the sensor to short range and display this
        MSSUMOsetShortRange(HTMSSUMO);
        displayCenteredTextLine(7, "Short range");
        shortrange = true;
      } else {
        // set the sensor to long range and display this
        MSSUMOsetLongRange(HTMSSUMO);
        displayCenteredTextLine(7, "Long range");
        shortrange = false;
      }
      playSound(soundBeepBeep);
      while(bSoundActive)
      time1[T1] = 0;
    }

    while(nNxtButtonPressed != kEnterButton) {
      zone = MSSUMOreadZone(HTMSSUMO);

      if (shortrange) {
        switch (zone) {
          case MSSUMO_NONE:  displayRICFile(0, 0, "sumonone.ric");  break;
          case MSSUMO_FRONT: displayRICFile(0, 0, "sumoSF.ric");  break;
          case MSSUMO_RIGHT:  displayRICFile(0, 0, "sumoSL.ric");  break;
          case MSSUMO_LEFT: displayRICFile(0, 0, "sumoSR.ric");  break;
        }
        displayCenteredTextLine(7, "Short range");
      } else {
        switch (zone) {
          case MSSUMO_NONE:  displayRICFile(0, 0, "sumonone.ric");  break;
          case MSSUMO_FRONT: displayRICFile(0, 0, "sumoLF.ric");  break;
          case MSSUMO_RIGHT:  displayRICFile(0, 0, "sumoLL.ric");  break;
          case MSSUMO_LEFT: displayRICFile(0, 0, "sumoLR.ric");  break;
        }
        displayCenteredTextLine(7, "Long range");
      }
      sleep(10);
    }
  }
}
