#pragma config(Sensor, S3,     MSTP,                sensorI2CCustom)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * mindsensors-touchpanel.h provides an API for the Mindsensors TouchPanel. This program
 * demonstrates how to use that API.
 *
 * Changelog:
 * - 0.1: Initial release
 *
 * Credits:
 * - Big thanks to Mindsensors for providing me with the hardware necessary to write and test this.
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * THIS CODE WILL ONLY WORK WITH ROBOTC VERSION 4.10 AND HIGHER

 * Xander Soldaat (xander_at_botbench.com)
 * 30 November 2011
 * version 0.1
 */

#include "mindsensors-touchpanel.h"

task main () {
  displayCenteredTextLine(0, "MindSensors");
  displayCenteredBigTextLine(1, "TouchPnl");
  displayCenteredTextLine(3, "Noise-a-Tron");
  displayCenteredTextLine(5, "Connect sensor");
  displayCenteredTextLine(6, "to S3");
  sleep(2000);
  eraseDisplay();

  short x, y = 0;
  ubyte buttons = 0;
  short multiplierX = 10;
  short multiplierY = 10;
  while (true) {
    if (!MSTPgetTouch(MSTP, x, y, buttons))
      playSound(soundBlip);
    else if (isButtonTouched(buttons, BUTTON_L1))
      multiplierX = 10;
    else if (isButtonTouched(buttons, BUTTON_L2))
      multiplierX = 15;
    else if (isButtonTouched(buttons, BUTTON_L3))
      multiplierX = 20;
    else if (isButtonTouched(buttons, BUTTON_L4))
      multiplierX = 25;
    else if (isButtonTouched(buttons, BUTTON_R1))
      multiplierY = 10;
    else if (isButtonTouched(buttons, BUTTON_R2))
      multiplierY = 15;
    else if (isButtonTouched(buttons, BUTTON_R3))
      multiplierY = 20;
    else if (isButtonTouched(buttons, BUTTON_R4))
      multiplierY = 25;

    else if (x > 0 && y > 0)
    {
      playImmediateTone(x * multiplierX, 1);
      sleep(10);
      playImmediateTone(y * multiplierY, 1);
      setPixel(x, y);
    }
    sleep(1);
  }
}
